#----------------------------------------------------#
# This script runs every game tick.
# Each part of the map is checked and calls another
# function to change the map accoriding to the
# detected action.
#
# Scripter: Liontack
# Called by function: tick
#----------------------------------------------------#



### Pressure plate opening door and loading room 1

execute if block 20 65 0 stone_pressure_plate[powered=true] run fill 19 65 1 19 67 -1 air
execute if block 20 65 0 air run fill 19 65 1 19 67 -1 ladder[facing=east]
execute if block 20 65 0 stone_pressure_plate[powered=true] if score i_room variables matches 0 run scoreboard players set b_run_time variables 1
execute if block 20 65 0 stone_pressure_plate[powered=true] if score i_room variables matches 0 as @r run loot spawn 0.5 6.5 0.5 loot main:playerhead
execute if block 20 65 0 stone_pressure_plate[powered=true] if score i_room variables matches 0 run tag @e[type=item, x=0, y=6, z=0, distance=..5, limit=1] add NoPickup
execute if block 20 65 0 stone_pressure_plate[powered=true] if score i_room variables matches 0 run team join no_push @a
execute if block 20 65 0 stone_pressure_plate[powered=true] if score i_room variables matches 0 positioned 32 62 -48 run function main:update_level/load_room_from_location



### Check submissions

execute if block 8 66 -1 warped_button[powered=true] if score i_room variables matches 1 run function main:update_level/room_1_submit
execute if block 8 66 -1 warped_button[powered=true] if score i_room variables matches 2 run function main:update_level/room_2_submit
execute if block 8 66 -1 warped_button[powered=true] if score i_room variables matches 3 run function main:update_level/room_3_submit
execute if block 8 66 -1 warped_button[powered=true] if score i_room variables matches 4 run function main:update_level/room_4_submit
execute if block 8 66 -1 warped_button[powered=true] if score i_room variables matches 5 run function main:update_level/room_5_submit
execute if block 8 66 -1 warped_button[powered=true] if score i_room variables matches 6 run function main:update_level/room_6_submit
execute if block 8 66 -1 warped_button[powered=true] if score i_room variables matches 7 run function main:update_level/room_7_submit
execute if block 8 66 -1 warped_button[powered=true] if score i_room variables matches 8 run function main:update_level/room_8_submit
execute if block 8 66 -1 warped_button[powered=true] if score i_room variables matches 9 run function main:update_level/room_9_submit
execute if block 8 66 -1 warped_button[powered=true] if score i_room variables matches 10 run function main:update_level/room_10_submit
execute if block 8 66 -1 warped_button[powered=true] if score i_room variables matches 11 run function main:update_level/room_11_submit
execute if block 8 66 -1 warped_button[powered=true] if score i_room variables matches 12 run function main:update_level/room_12_submit
execute if block 8 66 -1 warped_button[powered=true] if score i_room variables matches 13 run function main:update_level/room_13_submit
execute if block 8 66 -1 warped_button[powered=true] if score i_room variables matches 14 run function main:update_level/room_14_submit
execute if block 8 66 -1 warped_button[powered=true] if score i_room variables matches 15 run function main:update_level/room_15_submit
execute if block 8 66 -1 warped_button[powered=true] if score i_room variables matches 16 run function main:update_level/room_16_submit
execute if block 8 66 -1 warped_button[powered=true] if score i_room variables matches 17 run function main:update_level/room_17_submit
execute if block 8 66 -1 warped_button[powered=true] if score i_room variables matches 18 run function main:update_level/room_18_submit
execute if block 8 66 -1 warped_button[powered=true] if score i_room variables matches 19 run function main:update_level/room_19_submit
execute if block 8 66 -1 warped_button[powered=true] if score i_room variables matches 20 run function main:update_level/room_20_submit
execute if block 8 66 -1 warped_button[powered=true] if score i_room variables matches 21 run function main:update_level/room_21_submit
execute if block 8 66 -1 warped_button[powered=true] if score i_room variables matches 22 run function main:update_level/room_22_submit
execute if block 8 66 -1 warped_button[powered=true] if score i_room variables matches 23 run function main:update_level/room_23_submit

execute if block 8 66 -1 warped_button[powered=true] run scoreboard players add i_wrong_submissions variables 1
execute if block 8 66 -1 warped_button[powered=true] run setblock 8 66 -1 warped_button[powered=false, facing=south]



### Load new levels

execute if entity @p[x=-10, y=74, z=4, distance=..3] if score i_room variables matches 1 run fill -6 65 -3 -3 68 -1 air
execute if entity @p[x=-10, y=74, z=4, distance=..3] if score i_room variables matches 1 positioned 32 62 -32 run function main:update_level/load_room_from_location
execute if entity @p[x=-10, y=74, z=4, distance=..3] if score i_room variables matches 1 run scoreboard players set i_room variables 2

execute if entity @p[x=-10, y=74, z=-4, distance=..3] if score i_room variables matches 2 positioned 32 62 -16 run function main:update_level/load_room_from_location
execute if entity @p[x=-10, y=74, z=-4, distance=..3] if score i_room variables matches 2 run scoreboard players set i_room variables 3

execute if entity @p[x=4, y=74, z=-10, distance=..3] if score i_room variables matches 3 positioned 32 62 0 run function main:update_level/load_room_from_location
execute if entity @p[x=4, y=74, z=-10, distance=..3] if score i_room variables matches 3 run scoreboard players set i_room variables 4

execute if entity @p[x=10, y=74, z=-4, distance=..3] if score i_room variables matches 4 positioned 32 62 16 run function main:update_level/load_room_from_location
execute if entity @p[x=10, y=74, z=-4, distance=..3] if score i_room variables matches 4 run scoreboard players set i_room variables 5
execute if score i_room variables matches 5 unless entity @e[type=shulker, x=6, y=66, z=2, distance=..4] run summon shulker 6 66 2 {Color:16, Silent:1, Invulnerable:1, PersistenceRequired:1, DeathLootTable:"minecraft:empty", Attributes:[{Name:"generic.movement_speed",Base:0}]}
execute if score i_room variables matches 5 unless entity @e[type=fireball, x=-6, y=67, z=6, distance=..4] run summon fireball -6 67 6 {Silent:1, Invulnerable:1, PersistenceRequired:1, DeathLootTable:"minecraft:empty", Attributes:[{Name:"generic.movement_speed",Base:0}], ExplosionPower:0}

execute if entity @p[x=10, y=74, z=4, distance=..3] if score i_room variables matches 5 run kill @e[type=shulker_bullet, x=-7, y=64, z=-7, dx=15, dy=6, dz=15]
execute if entity @p[x=10, y=74, z=4, distance=..3] if score i_room variables matches 5 positioned 32 62 32 run function main:update_level/load_room_from_location
execute if entity @p[x=10, y=74, z=4, distance=..3] if score i_room variables matches 5 run scoreboard players set i_room variables 6

execute if entity @p[x=4, y=74, z=10, distance=..3] if score i_room variables matches 6 positioned 16 62 -48 run function main:update_level/load_room_from_location
execute if entity @p[x=4, y=74, z=10, distance=..3] if score i_room variables matches 6 run scoreboard players set i_room variables 7

execute if entity @p[x=-4, y=74, z=10, distance=..3] if score i_room variables matches 7 positioned 16 62 -32 run function main:update_level/load_room_from_location
execute if entity @p[x=-4, y=74, z=10, distance=..3] if score i_room variables matches 7 run scoreboard players set i_room variables 8

execute if entity @p[x=-4, y=74, z=-10, distance=..3] if score i_room variables matches 8 positioned 16 62 16 run function main:update_level/load_room_from_location
execute if entity @p[x=-4, y=74, z=-10, distance=..3] if score i_room variables matches 8 run scoreboard players set i_room variables 9

execute if entity @p[x=-9, y=80, z=0, distance=..3] if score i_room variables matches 9 run clone -20 89 -1 -18 92 1 -20 64 -1
execute if entity @p[x=-9, y=80, z=0, distance=..3] if score i_room variables matches 9 positioned 16 62 32 run function main:update_level/load_room_from_location
execute if entity @p[x=-9, y=80, z=0, distance=..3] if score i_room variables matches 9 run scoreboard players set i_room variables 10

execute if entity @p[x=-10, y=74, z=4, distance=..3] if score i_room variables matches 10 positioned 0 62 -48 run function main:update_level/load_room_from_location
execute if entity @p[x=-10, y=74, z=4, distance=..3] if score i_room variables matches 10 run scoreboard players set i_room variables 11

execute if entity @p[x=-10, y=74, z=-4, distance=..3] if score i_room variables matches 11 positioned 0 62 32 run function main:update_level/load_room_from_location
execute if entity @p[x=-10, y=74, z=-4, distance=..3] if score i_room variables matches 11 run scoreboard players set i_room variables 12

execute if entity @p[x=4, y=74, z=-10, distance=..3] if score i_room variables matches 12 positioned -16 62 -48 run function main:update_level/load_room_from_location
execute if entity @p[x=4, y=74, z=-10, distance=..3] if score i_room variables matches 12 run scoreboard players set i_room variables 13

execute if entity @p[x=10, y=74, z=-4, distance=..3] if score i_room variables matches 13 positioned -16 62 32 run function main:update_level/load_room_from_location
execute if entity @p[x=10, y=74, z=-4, distance=..3] if score i_room variables matches 13 run scoreboard players set i_room variables 14

execute if entity @p[x=10, y=74, z=4, distance=..3] if score i_room variables matches 14 positioned -32 62 -48 run function main:update_level/load_room_from_location
execute if entity @p[x=10, y=74, z=4, distance=..3] if score i_room variables matches 14 run scoreboard players set i_room variables 15

execute if entity @p[x=4, y=74, z=10, distance=..3] if score i_room variables matches 15 positioned -32 62 -32 run function main:update_level/load_room_from_location
execute if entity @p[x=4, y=74, z=10, distance=..3] if score i_room variables matches 15 run scoreboard players set i_room variables 16

execute if entity @p[x=-4, y=74, z=10, distance=..3] if score i_room variables matches 16 positioned -32 62 16 run function main:update_level/load_room_from_location
execute if entity @p[x=-4, y=74, z=10, distance=..3] if score i_room variables matches 16 run scoreboard players set i_room variables 17

execute if entity @p[x=-4, y=74, z=-10, distance=..3] if score i_room variables matches 17 positioned -32 62 32 run function main:update_level/load_room_from_location
execute if entity @p[x=-4, y=74, z=-10, distance=..3] if score i_room variables matches 17 run scoreboard players set i_room variables 18

execute if entity @p[x=-9, y=80, z=0, distance=..3] if score i_room variables matches 18 positioned -48 62 -48 run function main:update_level/load_room_from_location
execute if entity @p[x=-9, y=80, z=0, distance=..3] if score i_room variables matches 18 run scoreboard players set i_room variables 19

execute if entity @p[x=0, y=67, z=10, distance=..3] if score i_room variables matches 19 if blocks 0 67 10 0 67 10 0 69 10 all positioned -48 62 -32 run function main:update_level/load_room_from_location
execute if entity @p[x=0, y=67, z=10, distance=..3] if score i_room variables matches 19 if blocks 0 67 10 0 67 10 0 69 10 all run scoreboard players set i_room variables 20

execute if entity @p[x=-10, y=67, z=0, distance=..3] if score i_room variables matches 20 if blocks -10 67 0 -10 67 0 -10 69 0 all positioned -48 62 -16 run function main:update_level/load_room_from_location
execute if entity @p[x=-10, y=67, z=0, distance=..3] if score i_room variables matches 20 if blocks -10 67 0 -10 67 0 -10 69 0 all run scoreboard players set i_room variables 21

execute if entity @p[x=0, y=67, z=-10, distance=..3] if score i_room variables matches 21 if blocks 0 67 -10 0 67 -10 0 69 -10 all positioned -48 62 0 run function main:update_level/load_room_from_location
execute if entity @p[x=0, y=67, z=-10, distance=..3] if score i_room variables matches 21 if blocks 0 67 -10 0 67 -10 0 69 -10 all run scoreboard players set i_room variables 22

execute if entity @p[x=10, y=67, z=0, distance=..3] if score i_room variables matches 22 if blocks 10 67 0 10 67 0 10 69 0 all positioned -48 62 16 run function main:update_level/load_room_from_location
execute if entity @p[x=10, y=67, z=0, distance=..3] if score i_room variables matches 22 if blocks 10 67 0 10 67 0 10 69 0 all run scoreboard players set i_room variables 23
execute if score i_room variables matches 23 unless entity @e[type=item, x=-1.5, y=66.5, z=-3.5, distance=..1] run tp @e[type=item, x=0, y=6, z=0, distance=..5, limit=1] -1.5 66.5 -3.5


### Give hints

execute if block 8 66 1 crimson_button[powered=true] if score i_room variables matches 1 run tellraw @a [{"text":"[Hint 1] ", "color":"aqua"}, {"text":"Match the animals with their egg.", "color":"white"}]
execute if block 8 66 1 crimson_button[powered=true] if score i_room variables matches 2 run tellraw @a [{"text":"[Hint 2] ", "color":"aqua"}, {"text":"Crafting dyes.", "color":"white"}]
execute if block 8 66 1 crimson_button[powered=true] if score i_room variables matches 3 run tellraw @a [{"text":"[Hint 3] ", "color":"aqua"}, {"text":"Smelting.", "color":"white"}]
execute if block 8 66 1 crimson_button[powered=true] if score i_room variables matches 4 run tellraw @a [{"text":"[Hint 4] ", "color":"aqua"}, {"text":"I be-leave this hint wood not be needed.", "color":"white"}]
execute if block 8 66 1 crimson_button[powered=true] if score i_room variables matches 5 run tellraw @a [{"text":"[Hint 5] ", "color":"aqua"}, {"text":"Projectiles origin.", "color":"white"}]
execute if block 8 66 1 crimson_button[powered=true] if score i_room variables matches 6 run tellraw @a [{"text":"[Hint 6] ", "color":"aqua"}, {"text":"Half them are containers.", "color":"white"}]
execute if block 8 66 1 crimson_button[powered=true] if score i_room variables matches 7 run tellraw @a [{"text":"[Hint 7] ", "color":"aqua"}, {"text":"Crafting blocks.", "color":"white"}]
execute if block 8 66 1 crimson_button[powered=true] if score i_room variables matches 8 run tellraw @a [{"text":"[Hint 8] ", "color":"aqua"}, {"text":"Simply colors (Don't forget you have an inspector item!).", "color":"white"}]
execute if block 8 66 1 crimson_button[powered=true] if score i_room variables matches 9 run tellraw @a [{"text":"[Hint 9] ", "color":"aqua"}, {"text":"Thunder.", "color":"white"}]
execute if block 8 66 1 crimson_button[powered=true] if score i_room variables matches 10 run tellraw @a [{"text":"[Hint 10] ", "color":"aqua"}, {"text":"Exclusively.", "color":"white"}]
execute if block 8 66 1 crimson_button[powered=true] if score i_room variables matches 11 run tellraw @a [{"text":"[Hint 11] ", "color":"aqua"}, {"text":"Professions.", "color":"white"}]
execute if block 8 66 1 crimson_button[powered=true] if score i_room variables matches 12 run tellraw @a [{"text":"[Hint 12] ", "color":"aqua"}, {"text":"Crafting with an abundance of sticks.", "color":"white"}]
execute if block 8 66 1 crimson_button[powered=true] if score i_room variables matches 13 run tellraw @a [{"text":"[Hint 13] ", "color":"aqua"}, {"text":"Biome (Extra hint: Coral only spawns in the warmest version of the oceans: 'warm ocean').", "color":"white"}]
execute if block 8 66 1 crimson_button[powered=true] if score i_room variables matches 14 run tellraw @a [{"text":"[Hint 14] ", "color":"aqua"}, {"text":"Brewery (The inspector item can see which potion is which!).", "color":"white"}]
execute if block 8 66 1 crimson_button[powered=true] if score i_room variables matches 15 run tellraw @a [{"text":"[Hint 15] ", "color":"aqua"}, {"text":"Biomes again.", "color":"white"}]
execute if block 8 66 1 crimson_button[powered=true] if score i_room variables matches 16 run tellraw @a [{"text":"[Hint 16] ", "color":"aqua"}, {"text":"Mob drops.", "color":"white"}]
execute if block 8 66 1 crimson_button[powered=true] if score i_room variables matches 17 run tellraw @a [{"text":"[Hint 17] ", "color":"aqua"}, {"text":"Special items for 1 particular mob.", "color":"white"}]
execute if block 8 66 1 crimson_button[powered=true] if score i_room variables matches 18 run tellraw @a [{"text":"[Hint 18] ", "color":"aqua"}, {"text":"Baby mob's interests.", "color":"white"}]
execute if block 8 66 1 crimson_button[powered=true] if score i_room variables matches 19 run tellraw @a [{"text":"[Hint 19] ", "color":"aqua"}, {"text":"Use item on mob.", "color":"white"}]
execute if block 8 66 1 crimson_button[powered=true] if score i_room variables matches 20 run tellraw @a [{"text":"[Hint 20] ", "color":"aqua"}, {"text":"Predator and prey.", "color":"white"}]
execute if block 8 66 1 crimson_button[powered=true] if score i_room variables matches 21 run tellraw @a [{"text":"[Hint 21] ", "color":"aqua"}, {"text":"Depiction on chiseled block variants.", "color":"white"}]
execute if block 8 66 1 crimson_button[powered=true] if score i_room variables matches 22 run tellraw @a [{"text":"[Hint 22] ", "color":"aqua"}, {"text":"The inspector shows which instrument a noteblock plays. In the hall of tones, you can hear the noteblocks. If you are at a complete loss, you can use this online lookup table: ", "color":"white"}, {"text":"Note_block page","color":"aqua","bold":false,"underlined":true,"clickEvent":{"action":"open_url","value":"https://minecraft.gamepedia.com/Note_Block#Instruments"}}]
execute if block 8 66 1 crimson_button[powered=true] if score i_room variables matches 23 run tellraw @a [{"text":"[Hint 23] ", "color":"aqua"}, {"text":"Player's roles in this game.", "color":"white"}]

execute if block 8 66 1 crimson_button[powered=true] run scoreboard players add i_hints_used variables 1
execute if block 8 66 1 crimson_button[powered=true] run setblock 8 66 1 crimson_button[powered=false]
